<?php
//--------------------------------------------------------------------
//----- $Header: /home/cvsroot/sebek/server/html/sebek_utils.inc,v 1.1 2004/03/29 19:15:00 cvs Exp $
//--------------------------------------------------------------------
/*
 * Copyright (C) 2001 - 2003 The Honeynet Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by The Honeynet Project.
 * 4. The name "The Honeynet Project" may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
?>
<?php

include("config.inc");
function print_head($title,$head){

?>
<table border=0 cellspacing=0 cellpadding=0>

<?php 

if($head){ 
?>
  <tr class="title">
    <td border=0 class="title_left" ><img src="sebek.png"/></td>
    <td border=0 class="title">
	<a href="main.php" target="_top">Home</a> | 
    	<a href="ks_act.php" target="_top">Keystrokes</a> |
    	<a href="table_view.php" target="_top">Browse</a> |
	<a href="search.php" target="_top">Search</a> |
	<a href="db_manage.php" target="_top">db_manage</a>
    </td>

<?php
   $now = date("r");
   print "<td border=0 class=\"title\">$now</td>\n";

?>


  </tr>
<?php
}

  print "<tr>\n";
  print "<td border=0 class=\"title2\" colspan=\"3\">$title</td>\n";

?>  
  </tr>
</table>




<?php
}


function db_con(){

  global $db_host;
  global $db_uid;
  global $db_passwd;
  global $db_name;


  //----- connect to database server
  $dbref = mysql_connect($db_host,$db_uid,$db_passwd) or die ("Unable to connect to \"$db_host\" as \"$db_uid\"\n");

  
  //------ select the DB of interest
  mysql_select_db($db_name);


  return $dbref;
}


//--- need to add filtering ability by host/uid and time
function wordwrap2($str,$cols,$cut) {

$len=strlen($str);
 
 $tag=0;

 for ($i=0;$i<$len;$i++) {

   $chr = substr($str,$i,1);

   //if ($chr == "<")$tag++;
   //if ($chr == ">")$tag--;

   if (!$tag){
     $wordlen++;
     if (!($wordlen%$cols))$chr .= $cut;
     $result .= $chr;
   }else{
     $result .= $chr;
   }
 }
   
 return $result;
 
}



//---- takes data in the form of $fd[$timestamp][$index] = $readdata
function keystroke_data_merge($data){
  
 $log = array();
 $str = "";
 $logtime = 0;
  
 if(!is_array($data)){
   return;
 }

 //------ for a given process / fd work some rebuild magic
  foreach(array_keys($data) as $time){
    foreach(array_keys($data[$time]) as $idx){
      if(!$logtime){
	$logtime = $time;
      }

      $char = $data[$time][$idx];
      if(!strncasecmp($char,"\n",1) || !strncasecmp($char,"\r",1)){
	if($logtime){
	  $log[$logtime][] = $str;
	  $str = "";
	  $logtime = "";
	}
      }else{
	$str .= $char;
      }
    }	
  }
  
  if($logtime){
    //----- limit total len of keystrokes 
    $log[$logtime][] = $str;
  }

  return $log;
}


function scp_format($log, $txt,$ip,$pid,$fd){
  

  global $counter;
  
  $filestr = "";
  $observed_size = 0;


  if(!is_array($log)){
    return;
  }

  
  $output = array();


  //------ format the log lines
  foreach(array_keys($log) as $time){

    foreach(array_keys($log[$time]) as $idx){
  
      if(strlen($log[$time][$idx]) == 1){
	$filestr .= $log[$time][$idx];
	
      }else{
	$observed_size += strlen($log[$time][$idx]);
	$file          .= $log[$time][$idx];
      }

    }

  }

  $frags = explode(" ",rtrim($filestr));
  $perms = $frags[0];
  $size  = $frags[1];
  $fname = $frags[2];


  
  $query = "?fname=$fname&ip=$ip&pid=$pid&fd=$fd&size=$observed_size";

  print "<table border=0 cellspacing=0 cellpadding=0>\n";
  print "<tr><td colspan=2 class=\"title2\" >SCP File Transfer Decode $txt</td></tr>\n";
  print "<tr><td width=200 class=\"head2\">File Name:</td>";
  print "<td class=\"sum2\"><a href=\"scp_download.php$query\">$fname</a></td></tr>\n";
  print "<tr><td width=200 class=\"head2\">Expected Size:</td>";
  print "<td class=\"sum2\">$size bytes</td></tr>\n";
  print "<tr><td width=200 class=\"head2\">Observed Size:</td>";
  print "<td class=\"sum2\" >$observed_size bytes</td></tr>\n"; 
  print "<tr><td width=200 class=\"head2\">Permissions:</td>";
  print "<td  class=\"sum2\">$perms</td></tr>\n";

  $loss = $size - $observed_size;

  print "<tr><td width=200 class=\"head2\">Lost</td>";
  print "<td class=\"sum2\">$loss bytes</td></tr>\n";
  if(!$perms || !$size || !$fname){
    print "<tr><td colspan=2 class=\"head1\">This does not appear to be a a File Transfer</td></tr>\n";
  }

  print "</table>\n";

  return $output;

}



function keystroke_format($log,$txt,$limit){

  if($txt){
     print "<table border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td  class=\"title2\" >Text / Keystroke View $txt</td></tr>\n";
    print "<tr><td  class=\"data\">\n";			
  }
 
  if(!is_array($log)){
    return;
  }

  $stripstr = "\0..\37!@\177..\377";

  $escapes[chr(27)."[A" ]  = "<font class=\"ks_ctl\">[U-ARROW] </font> ";
  $escapes[chr(27)."[B" ]  = "<font class=\"ks_ctl\">[D-ARROW] </font> ";
  $escapes[chr(27)."[C" ]  = "<font class=\"ks_ctl\">[R-ARROW] </font> ";
  $escapes[chr(27)."[D" ]  = "<font class=\"ks_ctl\">[L-ARROW] </font> ";
  $escapes[chr(27)."[3~"]  = "<font class=\"ks_ctl\">[DEL] </font> ";
  $escapes[chr(27)."[5~"]  = "<font class=\"ks_ctl\">[PAGE-U] </font> ";
  $escapes[chr(27)."[6~"]  = "<font class=\"ks_ctl\">[PAGE-D] </font> ";
  $escapes[chr(127)     ]  = "<font class=\"ks_ctl\">[BS] </font> ";
  $escapes[chr(27)      ]  = "<font class=\"ks_ctl\">[ESC] </font> ";
  $escapes["\n"         ]  = "<br> \n ";
  $escapes["\t"         ]  = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  $escapes[" "          ]  = "&nbsp;";
  $output = array();

  $counter = 0;
  //------ format the log lines
  foreach(array_keys($log) as $time){
    foreach(array_keys($log[$time]) as $idx){
     
      if($limit){
	$text  = wordwrap2($log[$time][$idx],30,"\n");
        $lines = explode("\n",$text);	
      }else{
        $lines = explode("\n",$log[$time][$idx]);
      }

      
      //----- look at each line in log
      foreach(array_values($lines) as $line){
       
        $line = htmlspecialchars($line,ENT_QUOTES);
	$line = strtr($line,$escapes);
        $line = addcslashes($line, $stripstr);
        $output[] = "<font class=\"ks_t\">[$time]# </font><font class=\"ks_d\">$line<br></font>\n";
	

      }
    }
  }


  if($limit){
	$output2 = array_slice($output,sizeof($output) - $limit);
  }else{
       $output2 = $output;
  }

  foreach(array_values($output2) as $outline){
    print "$outline";
  }
  
  if($txt){
    print  "</td></tr>\n";
    print "</table\n";
  }

  return;

}


function print_keystroke_log($new,$odd,$ip,$uid,$pid,$com,$fd,$log,$limit){

  $c = "class=\"d1\"";
  print "<TR class=\"$odd\">";
  if($new){
    $query = "<a href=\"details.php?ip=$ip&pid=$pid&fd=$fd\"><img src=\"button.gif\" border=0></a>";
    print "<TD $c>$query</TD><TD $c>$ip </TD><TD $c>$pid</TD>";
    print "<TD $c>$uid  </TD><TD $c>$com</TD><TD $c>$fd</TD><TD class=\"data\">\n";
  }else{
    print "<TD $c></TD><TD $c></TD><TD $c></TD><TD $c>$uid</TD><TD $c>$com</TD><TD $c>$fd</TD><TD class=\"data\">\n";
  }
  
  keystroke_format($log,"",$limit);
  
  
  print "\t\t</TD>\n";
  print "\t</TR>\n";
    

 
}
//----------------------------------------------------------------------------------------------

?>
